Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 2696)
@@ -1701,334 +2170,65 @@
     ENDDO
 !
+!-- Finally, set identification flags indicating natural terrain or buildings.
+!-- Natural terrain grid points.
+    IF ( land_surface )  THEN
+       DO i = nxl, nxr
+          DO j = nys, nyn
+             DO k = nzb, nzt+1
+!
+!--             Natural terrain grid point
+                IF ( BTEST( topo(k,j,i), 1 ) )                                 &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 5 )
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+!
+!-- Building grid points.
+    IF ( urban_surface )  THEN
+       DO i = nxl, nxr
+          DO j = nys, nyn
+             DO k = nzb, nzt+1
+                IF ( BTEST( topo(k,j,i), 2 ) )                                 &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 6 )
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+!
 !-- Exchange ghost points for wall flags
-    CALL exchange_horiz_int( wall_flags_0, nbgp )
+    CALL exchange_horiz_int( wall_flags_0, nys, nyn, nxl, nxr, nzt, nbgp )
 !
 !-- Set boundary conditions also for flags. Can be interpreted as Neumann
 !-- boundary conditions for topography. 
     IF ( .NOT. bc_ns_cyc )  THEN
-       IF ( nys == 0  )  wall_flags_0(:,-1,:)   = wall_flags_0(:,0,:)
-       IF ( nyn == ny )  wall_flags_0(:,ny+1,:) = wall_flags_0(:,ny,:)
+       IF ( nys == 0  )  THEN
+          DO  i = 1, nbgp     
+             wall_flags_0(:,nys-i,:)   = wall_flags_0(:,nys,:)
+          ENDDO
+       ENDIF
+       IF ( nyn == ny )  THEN
+          DO  i = 1, nbgp  
+             wall_flags_0(:,nyn+i,:) = wall_flags_0(:,nyn,:)
+          ENDDO
+       ENDIF
     ENDIF
     IF ( .NOT. bc_lr_cyc )  THEN
-       IF ( nxl == 0  )  wall_flags_0(:,:,-1)   = wall_flags_0(:,:,0)
-       IF ( nxr == nx )  wall_flags_0(:,:,nx+1) = wall_flags_0(:,:,nx)           
+       IF ( nxl == 0  )  THEN
+          DO  i = 1, nbgp   
+             wall_flags_0(:,:,nxl-i)   = wall_flags_0(:,:,nxl)
+          ENDDO
+       ENDIF
+       IF ( nxr == nx )  THEN 
+          DO  i = 1, nbgp   
+             wall_flags_0(:,:,nxr+i) = wall_flags_0(:,:,nxr)     
+          ENDDO
+       ENDIF      
     ENDIF
 
-!
-!-- Initialize boundary conditions via surface type
-    CALL init_bc
-!
-!-- Allocate and set topography height arrays required for data output
-    IF ( TRIM( topography ) /= 'flat' )  THEN
-!
-!--    Allocate and set the arrays containing the topography height
-
-       IF ( nxr == nx  .AND.  nyn /= ny )  THEN
-          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn),                             &
-                    zw_w_inner(nxl:nxr+1,nys:nyn) )
-       ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
-          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn+1),                             &
-                    zw_w_inner(nxl:nxr,nys:nyn+1) )
-       ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
-          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn+1),                           &
-                    zw_w_inner(nxl:nxr+1,nys:nyn+1) )
-       ELSE
-          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn),                               &
-                    zw_w_inner(nxl:nxr,nys:nyn) )
-       ENDIF
-
-       zu_s_inner   = 0.0_wp
-       zw_w_inner   = 0.0_wp
-!
-!--    Determine local topography height on scalar and w-grid. Note, setting
-!--    lateral boundary values is not necessary, realized via wall_flags_0 
-!--    array. Further, please note that loop bounds are different from 
-!--    nxl to nxr and nys to nyn on south and right model boundary, hence, 
-!--    use intrinsic lbound and ubound functions to infer array bounds.
-       DO  i = LBOUND(zu_s_inner, 1), UBOUND(zu_s_inner, 1)
-          DO  j = LBOUND(zu_s_inner, 2), UBOUND(zu_s_inner, 2)
-!
-!--          Topography height on scalar grid. Therefore, determine index of 
-!--          upward-facing surface element on scalar grid. 
-             zu_s_inner(i,j) = zu( get_topography_top_index( j, i, 's' ) )
-!
-!--          Topography height on w grid. Therefore, determine index of 
-!--          upward-facing surface element on w grid.
-             zw_w_inner(i,j) = zw( get_topography_top_index( j, i, 's' ) )
-          ENDDO
-       ENDDO
-
-    ENDIF
-
-!
-!-- Calculate wall flag arrays for the multigrid method.
-!-- Please note, wall flags are only applied in the not cache-optimized 
-!-- version.
-    IF ( psolver == 'multigrid_noopt' )  THEN
-
-!
-!--    Gridpoint increment of the current level. 
-       inc = 1
-       DO  l = maximum_grid_level, 1 , -1
-!
-!--       Set grid_level as it is required for exchange_horiz_2d_int
-          grid_level = l
-
-          nxl_l = nxl_mg(l)
-          nxr_l = nxr_mg(l)
-          nys_l = nys_mg(l)
-          nyn_l = nyn_mg(l)
-          nzt_l = nzt_mg(l)
-!
-!--       Assign the flag level to be calculated
-          SELECT CASE ( l )
-             CASE ( 1 )
-                flags => wall_flags_1
-             CASE ( 2 )
-                flags => wall_flags_2
-             CASE ( 3 )
-                flags => wall_flags_3
-             CASE ( 4 )
-                flags => wall_flags_4
-             CASE ( 5 )
-                flags => wall_flags_5
-             CASE ( 6 )
-                flags => wall_flags_6
-             CASE ( 7 )
-                flags => wall_flags_7
-             CASE ( 8 )
-                flags => wall_flags_8
-             CASE ( 9 )
-                flags => wall_flags_9
-             CASE ( 10 )
-                flags => wall_flags_10
-          END SELECT
-
-!
-!--       Depending on the grid level, set the respective bits in case of
-!--       neighbouring walls
-!--       Bit 0:  wall to the bottom
-!--       Bit 1:  wall to the top (not realized in remaining PALM code so far)
-!--       Bit 2:  wall to the south
-!--       Bit 3:  wall to the north
-!--       Bit 4:  wall to the left
-!--       Bit 5:  wall to the right
-!--       Bit 6:  inside building
-
-          flags = 0
-
-!
-!--       In case of masking method, flags are not set and multigrid method
-!--       works like FFT-solver
-          IF ( .NOT. masking_method )  THEN
-
-!
-!--          Allocate temporary array for topography heights on coarser grid
-!--          level. Please note, 2 ghoist points are required, in order to
-!--          calculate flags() on the interior ghost point. 
-             ALLOCATE( nzb_tmp(nys_l-2:nyn_l+2,nxl_l-2:nxr_l+2) )
-             nzb_tmp = 0
-             
-             DO  i = nxl_l, nxr_l
-                DO  j = nys_l, nyn_l
-                   nzb_tmp(j,i) = nzb_local(j*inc,i*inc)
-                ENDDO
-             ENDDO
-!
-!--          Exchange ghost points on respective multigrid level. 2 ghost points
-!--          are required, in order to calculate flags on 
-!--          nys_l-1 / nyn_l+1 / nxl_l-1 / nxr_l+1. The alternative would be to 
-!--          exchange 3D-INTEGER array flags on the respective multigrid level.
-             CALL exchange_horiz_2d_int( nzb_tmp, nys_l, nyn_l, nxl_l, nxr_l, 2 )
-!
-!--          Set non-cyclic boundary conditions on respective multigrid level
-             IF ( .NOT. bc_ns_cyc )  THEN
-                IF ( inflow_s .OR. outflow_s .OR. nest_bound_s  )  THEN
-                   nzb_tmp(-2,:) = nzb_tmp(0,:)
-                   nzb_tmp(-1,:) = nzb_tmp(0,:)
-                ENDIF
-                IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
-                   nzb_tmp(nyn_l+2,:) = nzb_tmp(nyn_l,:)
-                   nzb_tmp(nyn_l+1,:) = nzb_tmp(nyn_l,:)
-                ENDIF
-             ENDIF
-             IF ( .NOT. bc_lr_cyc )  THEN
-                IF ( inflow_l .OR. outflow_l .OR. nest_bound_l  )  THEN
-                   nzb_tmp(:,-2) = nzb_tmp(:,0)
-                   nzb_tmp(:,-1) = nzb_tmp(:,0)
-                ENDIF
-                IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
-                   nzb_tmp(:,nxr_l+1) = nzb_tmp(:,nxr_l)    
-                   nzb_tmp(:,nxr_l+2) = nzb_tmp(:,nxr_l)      
-                ENDIF        
-             ENDIF
-                       
-             DO  i = nxl_l-1, nxr_l+1
-                DO  j = nys_l-1, nyn_l+1
-                   DO  k = nzb, nzt_l+1     
-!
-!--                   Inside/outside building (inside building does not need
-!--                   further tests for walls)
-                      IF ( k*inc <= nzb_tmp(j,i) )  THEN
-
-                         flags(k,j,i) = IBSET( flags(k,j,i), 6 )
-
-                      ELSE
-!
-!--                      Bottom wall
-                         IF ( (k-1)*inc <= nzb_tmp(j,i) )  THEN
-                            flags(k,j,i) = IBSET( flags(k,j,i), 0 )
-                         ENDIF
-!
-!--                      South wall
-                         IF ( k*inc <= nzb_tmp(j-1,i) )  THEN
-                            flags(k,j,i) = IBSET( flags(k,j,i), 2 )
-                         ENDIF
-!
-!--                      North wall
-                         IF ( k*inc <= nzb_tmp(j+1,i) )  THEN
-                            flags(k,j,i) = IBSET( flags(k,j,i), 3 )
-                         ENDIF
-!
-!--                      Left wall
-                         IF ( k*inc <= nzb_tmp(j,i-1) )  THEN
-                            flags(k,j,i) = IBSET( flags(k,j,i), 4 )
-                         ENDIF
-!
-!--                      Right wall
-                         IF ( k*inc <= nzb_tmp(j,i+1) )  THEN
-                            flags(k,j,i) = IBSET( flags(k,j,i), 5 )
-                         ENDIF
-
-                      ENDIF
-                            
-                   ENDDO
-                ENDDO
-             ENDDO
-
-             DEALLOCATE( nzb_tmp )
-
-          ENDIF
-
-          inc = inc * 2
-
-       ENDDO
-!
-!--    Reset grid_level to "normal" grid
-       grid_level = 0
-       
-    ENDIF
-!
-!-- Allocate flags needed for masking walls. Even though these flags are only
-!-- required in the ws-scheme, the arrays need to be allocated here as they are 
-!-- used in OpenACC directives. 
-    ALLOCATE( advc_flags_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                     &
-              advc_flags_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-    advc_flags_1 = 0
-    advc_flags_2 = 0
-!
-!-- Init flags for ws-scheme to degrade order of the numerics near walls, i.e. 
-!-- to decrease the numerical stencil appropriately.
-    IF ( momentum_advec == 'ws-scheme'  .OR.  scalar_advec == 'ws-scheme'      &
-       )  THEN
-       CALL ws_init_flags
-    ENDIF
-
-!
-!-- In case of topography: limit near-wall mixing length l_wall further:
-!-- Go through all points of the subdomain one by one and look for the closest
-!-- surface
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-!
-!--          Check if current gridpoint belongs to the atmosphere
-             IF ( BTEST( wall_flags_0(k,j,i), 0 ) )  THEN
-!
-!--             Check for neighbouring grid-points.
-!--             Vertical distance, down
-                IF ( .NOT. BTEST( wall_flags_0(k-1,j,i), 0 ) )                 &
-                   l_wall(k,j,i) = MIN( l_grid(k), zu(k) - zw(k-1) )
-!
-!--             Vertical distance, up
-                IF ( .NOT. BTEST( wall_flags_0(k+1,j,i), 0 ) )                 &
-                   l_wall(k,j,i) = MIN( l_grid(k), zw(k) - zu(k) )
-!
-!--             y-distance
-                IF ( .NOT. BTEST( wall_flags_0(k,j-1,i), 0 )  .OR.             &
-                     .NOT. BTEST( wall_flags_0(k,j+1,i), 0 ) )                 &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), 0.5_wp * dy )
-!
-!--             x-distance
-                IF ( .NOT. BTEST( wall_flags_0(k,j,i-1), 0 )  .OR.             &
-                     .NOT. BTEST( wall_flags_0(k,j,i+1), 0 ) )                 &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), 0.5_wp * dx )
-!
-!--              yz-distance (vertical edges, down)
-                 IF ( .NOT. BTEST( wall_flags_0(k-1,j-1,i), 0 )  .OR.          &
-                      .NOT. BTEST( wall_flags_0(k-1,j+1,i), 0 )  )             &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
-                                        SQRT( 0.25_wp * dy**2 +                &
-                                       ( zu(k) - zw(k-1) )**2 ) )
-!
-!--              yz-distance (vertical edges, up)
-                 IF ( .NOT. BTEST( wall_flags_0(k+1,j-1,i), 0 )  .OR.          &
-                      .NOT. BTEST( wall_flags_0(k+1,j+1,i), 0 )  )             &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
-                                        SQRT( 0.25_wp * dy**2 +                &
-                                       ( zw(k) - zu(k) )**2 ) )
-!
-!--              xz-distance (vertical edges, down)
-                 IF ( .NOT. BTEST( wall_flags_0(k-1,j,i-1), 0 )  .OR.          &
-                      .NOT. BTEST( wall_flags_0(k-1,j,i+1), 0 )  )             &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
-                                        SQRT( 0.25_wp * dx**2 +                &
-                                       ( zu(k) - zw(k-1) )**2 ) )
-!
-!--              xz-distance (vertical edges, up)
-                 IF ( .NOT. BTEST( wall_flags_0(k+1,j,i-1), 0 )  .OR.          &
-                      .NOT. BTEST( wall_flags_0(k+1,j,i+1), 0 )  )             &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
-                                        SQRT( 0.25_wp * dx**2 +                &
-                                       ( zw(k) - zu(k) )**2 ) )
-!
-!--             xy-distance (horizontal edges)
-                IF ( .NOT. BTEST( wall_flags_0(k,j-1,i-1), 0 )  .OR.           &
-                     .NOT. BTEST( wall_flags_0(k,j+1,i-1), 0 )  .OR.           &
-                     .NOT. BTEST( wall_flags_0(k,j-1,i+1), 0 )  .OR.           &
-                     .NOT. BTEST( wall_flags_0(k,j+1,i+1), 0 ) )               &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
-                                        SQRT( 0.25_wp * ( dx**2 + dy**2 ) ) )
-!
-!--             xyz distance (vertical and horizontal edges, down)
-                IF ( .NOT. BTEST( wall_flags_0(k-1,j-1,i-1), 0 )  .OR.         &
-                     .NOT. BTEST( wall_flags_0(k-1,j+1,i-1), 0 )  .OR.         &
-                     .NOT. BTEST( wall_flags_0(k-1,j-1,i+1), 0 )  .OR.         &
-                     .NOT. BTEST( wall_flags_0(k-1,j+1,i+1), 0 ) )             &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
-                                        SQRT( 0.25_wp * ( dx**2 + dy**2 )      &
-                                              +  ( zu(k) - zw(k-1) )**2  ) )
-!
-!--             xyz distance (vertical and horizontal edges, up)
-                IF ( .NOT. BTEST( wall_flags_0(k+1,j-1,i-1), 0 )  .OR.         &
-                     .NOT. BTEST( wall_flags_0(k+1,j+1,i-1), 0 )  .OR.         &
-                     .NOT. BTEST( wall_flags_0(k+1,j-1,i+1), 0 )  .OR.         &
-                     .NOT. BTEST( wall_flags_0(k+1,j+1,i+1), 0 ) )             &
-                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
-                                        SQRT( 0.25_wp * ( dx**2 + dy**2 )      &
-                                              +  ( zw(k) - zu(k) )**2  ) )
-                  
-             ENDIF
-          ENDDO
-       ENDDO
-    ENDDO
-!
-!-- Set lateral boundary conditions for l_wall
-    CALL exchange_horiz( l_wall, nbgp )     
-
-!
-!-- Vertical nesting: communicate vertical grid level arrays between fine and
-!-- coarse grid
-    IF ( vnested )  CALL vnest_init_grid
-
- END SUBROUTINE init_grid
+
+ END SUBROUTINE set_topo_flags
+
+
+
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file init_masks.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/init_ocean.f90
===================================================================
--- palm/trunk/SOURCE/init_ocean.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_ocean.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file init_ocean.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file init_pegrid.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! 3D-Integer exchange on multigrid level (MS)
+! Forcing implemented (MS)
+! 
+! 2600 2017-11-01 14:11:20Z raasch
 ! calculation of block-I/O quantitites removed (is now done in parin)
 ! 
@@ -204,4 +208,6 @@
 !> user)and computation of the grid point number and array bounds of the local
 !> domains.
+!> @todo: remove MPI-data types for 2D exchange on coarse multigrid level (not
+!>        used any more) 
 !------------------------------------------------------------------------------!
  SUBROUTINE init_pegrid
@@ -210,5 +216,6 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr, bc_ns, coupling_mode, coupling_mode_remote,              &
-               coupling_topology, gathered_size, grid_level,                   &
+               coupling_topology, force_bound_l, force_bound_n, force_bound_r, &
+               force_bound_s, gathered_size, grid_level,                       &
                grid_level_count, inflow_l, inflow_n, inflow_r, inflow_s,       &
                maximum_grid_level, message_string,                             &
@@ -352,5 +359,4 @@
     CALL MPI_CART_SHIFT( comm2d, 0, 1, pleft, pright, ierr )
     CALL MPI_CART_SHIFT( comm2d, 1, 1, psouth, pnorth, ierr )
-
 !
 !-- In case of cyclic boundary conditions, a y-shift at the boundaries in
@@ -405,5 +411,4 @@
        ENDIF
     ENDIF
-
 !
 !-- Vertical nesting: store four lists that identify partner ranks to exchange 
@@ -700,5 +705,4 @@
 #endif
 
-
 ! 
 !-- Determine the number of ghost point layers
@@ -823,5 +827,4 @@
 !-- Create custom MPI vector datatypes for contiguous data transfer
     IF ( vnested )  CALL vnest_init_pegrid_domain
-
 
 #else
@@ -1096,6 +1099,12 @@
 !-- Do these calculations for the model grid and (if necessary) also
 !-- for the coarser grid levels used in the multigrid method
-    ALLOCATE ( ngp_xz(0:maximum_grid_level), ngp_yz(0:maximum_grid_level),     &
-               type_xz(0:maximum_grid_level), type_yz(0:maximum_grid_level) )
+    ALLOCATE ( ngp_xz(0:maximum_grid_level),                                   &
+               ngp_xz_int(0:maximum_grid_level),                               &
+               ngp_yz(0:maximum_grid_level),                                   &
+               ngp_yz_int(0:maximum_grid_level),                               &
+               type_xz(0:maximum_grid_level),                                  &
+               type_xz_int(0:maximum_grid_level),                              &
+               type_yz(0:maximum_grid_level),                                  &
+               type_yz_int(0:maximum_grid_level) )
 
     nxl_l = nxl; nxr_l = nxr; nys_l = nys; nyn_l = nyn; nzb_l = nzb; nzt_l = nzt
@@ -1125,4 +1134,16 @@
 
 !
+!-- Define data types for exchange of 3D Integer arrays.
+    ngp_yz_int(0) = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
+
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz_int(0),   &
+                          MPI_INTEGER, type_xz_int(0), ierr )
+    CALL MPI_TYPE_COMMIT( type_xz_int(0), ierr )
+
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz_int(0), ngp_yz_int(0), MPI_INTEGER,     &
+                          type_yz_int(0), ierr )
+    CALL MPI_TYPE_COMMIT( type_yz_int(0), ierr )
+
+!
 !-- Definition of MPI-datatypes for multigrid method (coarser level grids)
     IF ( psolver(1:9) == 'multigrid' )  THEN
@@ -1131,15 +1152,33 @@
        DO  i = maximum_grid_level, 1 , -1
 !
-!--       For 3D-exchange
+!--       For 3D-exchange on different multigrid level, one ghost point for 
+!--       REAL arrays, two ghost points for INTEGER arrays
           ngp_xz(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
           ngp_yz(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
 
-          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz(i), &
+          ngp_xz_int(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
+          ngp_yz_int(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
+!
+!--       MPI data type for REAL arrays, for xz-layers
+          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz(i),       &
                                 MPI_REAL, type_xz(i), ierr )
           CALL MPI_TYPE_COMMIT( type_xz(i), ierr )
 
+!
+!--       MPI data type for INTEGER arrays, for xz-layers
+          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz_int(i),   &
+                                MPI_INTEGER, type_xz_int(i), ierr )
+          CALL MPI_TYPE_COMMIT( type_xz_int(i), ierr )
+
+!
+!--       MPI data type for REAL arrays, for yz-layers
           CALL MPI_TYPE_VECTOR( 1, ngp_yz(i), ngp_yz(i), MPI_REAL, type_yz(i), &
                                 ierr )
           CALL MPI_TYPE_COMMIT( type_yz(i), ierr )
+!
+!--       MPI data type for INTEGER arrays, for yz-layers
+          CALL MPI_TYPE_VECTOR( 1, ngp_yz_int(i), ngp_yz_int(i), MPI_INTEGER,  &
+                                type_yz_int(i), ierr )
+          CALL MPI_TYPE_COMMIT( type_yz_int(i), ierr )
 
 
@@ -1155,6 +1194,4 @@
           CALL MPI_TYPE_COMMIT( type_y_int(i), ierr )
 
-
-
           nxl_l = nxl_l / 2
           nxr_l = nxr_l / 2
@@ -1166,15 +1203,4 @@
 
     ENDIF
-!
-!-- Define data types for exchange of 3D Integer arrays.
-    ngp_yz_int = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
-
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz_int, &
-                          MPI_INTEGER, type_xz_int, ierr )
-    CALL MPI_TYPE_COMMIT( type_xz_int, ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz_int, ngp_yz_int, MPI_INTEGER, type_yz_int, &
-                          ierr )
-    CALL MPI_TYPE_COMMIT( type_yz_int, ierr )
 
 #endif
@@ -1190,4 +1216,6 @@
        ELSEIF ( bc_lr == 'nested' )  THEN
           nest_bound_l = .TRUE.
+       ELSEIF ( bc_lr == 'forcing' )  THEN
+          force_bound_l = .TRUE.
        ENDIF
     ENDIF
@@ -1200,4 +1228,6 @@
        ELSEIF ( bc_lr == 'nested' )  THEN
           nest_bound_r = .TRUE.
+       ELSEIF ( bc_lr == 'forcing' )  THEN
+          force_bound_r = .TRUE.
        ENDIF
     ENDIF
@@ -1210,4 +1240,6 @@
        ELSEIF ( bc_ns == 'nested' )  THEN
           nest_bound_s = .TRUE.
+       ELSEIF ( bc_ns == 'forcing' )  THEN
+          force_bound_s = .TRUE.
        ENDIF
     ENDIF
@@ -1220,4 +1252,6 @@
        ELSEIF ( bc_ns == 'nested' )  THEN
           nest_bound_n = .TRUE.
+       ELSEIF ( bc_ns == 'forcing' )  THEN
+          force_bound_n = .TRUE.
        ENDIF
     ENDIF
@@ -1295,10 +1329,10 @@
 !-- At the inflow or outflow, u or v, respectively, have to be calculated for
 !-- one more grid point.
-    IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+    IF ( inflow_l .OR. outflow_l .OR. nest_bound_l .OR. force_bound_l )  THEN
        nxlu = nxl + 1
     ELSE
        nxlu = nxl
     ENDIF
-    IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+    IF ( inflow_s .OR. outflow_s .OR. nest_bound_s .OR. force_bound_s )  THEN
        nysv = nys + 1
     ELSE
Index: palm/trunk/SOURCE/init_pt_anomaly.f90
===================================================================
--- palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file init_pt_anomaly.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/init_rankine.f90
===================================================================
--- palm/trunk/SOURCE/init_rankine.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_rankine.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file init_rankine.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/init_slope.f90
===================================================================
--- palm/trunk/SOURCE/init_slope.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_slope.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file init_slope.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/interaction_droplets_ptq.f90
===================================================================
--- palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 2693)
+++ palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file interaction_droplets_ptq.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
